<?php
//
//	file: install_att/install.php
//	author: ptirhiik
//	begin: 13/02/2006
//	version: 1.6.3 - 27/06/2007
//	license: http://opensource.org/licenses/gpl-license.php GNU General Public License (GPL)
//
//	based on : attachment_mod copyright (c) 2002 Meik Sievertsen (acydburn)
//

define('IN_PHPBB', true);
define('IN_INSTALL', true);

$phpbb_root_path = './../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
$requester = 'install_inline_banner_ad/install';

include($phpbb_root_path . 'common.'.$phpEx);
include($config->url('includes/class_install'));
include($config->url('includes/class_cp'));
include($config->url('includes/inline_ad/class_inline_banner_ad'));

// script def
$requester = 'install_inline_banner_ad/' . basename(__FILE__, '.' . $phpEx);

// constants
define('ROWS_A_TURN', 500);

// tpls
function welcome_form()
{
	global $page;
?><form name="post" method="post" action="<?php echo $page->url(); ?>"><br /><br /><div align="center"><table cellpadding="4" cellspacing="1" border="0" width="80%" class="background">
<tr><th><?php echo sprintf($page->lang('IN_welcome'), INLINE_BANNER_AD_CURRENT_VERSION); ?></th></tr>
<tr><td align="justify" class="row1"><?php echo sprintf($page->lang('IN_welcome_explain'), INLINE_BANNER_AD_CURRENT_VERSION); ?><br /><br /><br /></td></tr>
<tr><td align="center" class="row2"><?php echo $page->lang('IN_start'); ?>: <input name="submit" type="submit" value="<?php echo $page->lang('IN_proceed'); ?>" /></td></tr>
</table></div><?php $page->hide(); ?></form>
<?php
}

function percent_box($title, $percent)
{
	global $page;
	$mult = 2;
	$page->output('<table cellpadding="1" cellspacing="0" border="0"><tr><td>' . $title . ':&nbsp;</td><td style="width: ' . (100 * $mult) . 'px; height: 13px; background-color: #FEFEFF; border: 1px #98AAB1 solid;"><div style="width: ' . ($percent * $mult). 'px; height: 13px; background-color: #00D000;"></div></td></tr></table>');
}

// steps
$steps = array(
'IN_welcome',
'IN_previous_version',
'IN_db',

//-- end of process
'IN_patch',
'IN_end',
);

// parms (not set is : type => TYPE_INT, default => 0)
$parms_def = array(
'step' => array('list' => &$steps),
'inpvch' => array('type' => TYPE_NO_HTML, 'default' => ''),
'inpvreg' => array('type' => TYPE_NO_HTML, 'default' => ''),
'db' => '',

'mcfg' => '',
'mdbdrop' => array('type' => TYPE_NO_HTML, 'default' => ''),

'catt' => '',
'tatt' => '',

'inp' => '',
// errors in droping tables
'errcfg' => '',
'errextgrp' => '',
'errext' => '',
'errextforb' => '',
);

// step functions
function step()
{
	global $parms, $steps;
	return $steps[ $parms['step'] ];
}
function next_step($step='')
{
	global $page, $parms, $steps;
	if ( !empty($step) )
	{
		$t_steps = array_flip($steps);
		$parms['step'] = $t_steps[$step];
	}
	else
	{
		$parms['step']++;
	}
	$page->set_parms($parms);
}

function read_file($file)
{
	$data = @fread(@fopen($file, 'r'), @filesize($file));
	return $data ? "\n" . trim($data) : '';
}


function encode_new_permissions($forums_list)
{
	$res = '';
	if ( !empty($forums_list) )
	{
		$res = substr(',' . implode(',', array_map('dechex', $forums_list)) . ',', 0, 255);
		$res = substr($res, 0, strrpos(',' . $res, ','));
	}
	return $res;
}
function decode_old_permissions($forum_permissions)
{
	$one_char_encoding = '#';
	$two_char_encoding = '.';
	$auth = array();
	$auth_len = 1;
	$strlen_forum_permissions = strlen($forum_permissions);
	for ($pos = 0; $pos < $strlen_forum_permissions; $pos += $auth_len)
	{
		$forum_auth = substr($forum_permissions, $pos, 1);
		if ($forum_auth == $one_char_encoding)
		{
			$auth_len = 1;
			continue;
		}
		else if ($forum_auth == $two_char_encoding)
		{
			$auth_len = 2;
			$pos--;
			continue;
		}
		$forum_auth = substr($forum_permissions, $pos, $auth_len);
		$forum_id = base64_unpack($forum_auth);
		$auth[] = intval($forum_id);
	}
	return $auth;
}
function base64_unpack($string)
{
	$chars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ+-';
	$base = strlen($chars);

	$length = strlen($string);
	$number = 0;

	for($i = 1; $i <= $length; $i++)
	{
		$pos = $length - $i;
		$operand = strpos($chars, substr($string,$pos,1));
		$exponent = pow($base, $i-1);
		$decValue = $operand * $exponent;
		$number += $decValue;
	}

	return $number;
}

//--------------------------------------
//
// Start the process
//
//--------------------------------------

// parms reading
$parms = array();
foreach ( $parms_def as $parm => $data )
{
	$type = empty($data) || !isset($data['type']) ? TYPE_INT : $data['type'];
	$default = empty($data) || !isset($data['default']) ? (($type == TYPE_INT) ? 0 : '') : $data['default'];
	$list = empty($data) || !isset($data['list']) ? '' : $data['list'];
	$parms[$parm] = _read($parm, $type, $default, $list);
}

// start
$page = new page($requester, '', 'lang_CH_install_inline_banner_ad');
$page->set_parms($parms);
$page->sub_title = '';

// set version
$lang['Script_title'] = sprintf($lang['Script_title'], INLINE_BANNER_AD_CURRENT_VERSION);

// log in
$session = new light_session();
$session->log_in(ADMIN);

// send welcome
if ( step() == 'IN_welcome' )
{
	$page->header();
	next_step();
	welcome_form();
	$page->footer();
}

// detect Inline Banner Ad
if ( step() == 'IN_previous_version' )
{
	// get actual version
	$parms['inpvch'] = '';
	$sql = 'SELECT config_value
				FROM ' . CONFIG_TABLE . '
				WHERE config_name = \'mod_inline_banner_ad_version_CH\'';
	$result = $db->sql_query($sql, false, __LINE__, __FILE__);
	if ( $row = $db->sql_fetchrow($result) )
	{
		$parms['inpvch'] = $row['config_value'];
	}
	$db->sql_freeresult($result);

	next_step();
}

// display previous version
if ( !empty($parms['inpvch']) )
{
	$page->output(sprintf($page->lang('IN_previous_version_CH'), $parms['inpvch']));
}

// -----------------------------------------
//
// create or upgrade the database structure
//
// -----------------------------------------
if ( step() == 'IN_db' )
{
	// get the db install layer
	if ( !($sql_layer = $db->get_layer()) )
	{
		$page->critical_error('IN_db_not_supported');
	}
	if ( $sql_layer['SCHEMA'] == 'postgres' )
	{
		$sql_layer['SCHEMA'] = 'pgsql';
	}
	$dbi_layer = 'dbi_' . $sql_layer['SCHEMA'];

	// include the layers
	include($config->url('includes/class_xml'));
	include($config->url('includes/db/class_dbi'));
	include($config->url('includes/db/class_' . $dbi_layer));

	// read the sql instructions
	$schemas = array();
	switch ( $parms['inpvch'] )
	{
		// new install
		default:
			$schemas[] = 'schema_ch';
			break;
	}

	// process the schemas
	$xml_parser = new xml_parser();
	$dbi = new $dbi_layer($table_prefix);
	$count_schemas = count($schemas);
	for ( $i = 0; $i < $count_schemas; $i++ )
	{
		// read & parse the XML schema
		$actions = false;
		if ( ($xml_name = phpbb_realpath($phpbb_root_path . 'install_inline_banner_ad/schemas/' . $schemas[$i] . '.xml')) && ($handler = @fopen($xml_name, 'r')) )
		{
			$xml = trim(fread($handler, filesize($xml_name)));
			fclose($handler);
			unset($handler);
			$actions = empty($xml) ? false : $xml_parser->parse($xml);
			unset($xml);
			if ( $actions === false )
			{
				$page->critical_error($xml_parser->errmsg);
			}
		}

		// process the sqls
		if ( $actions && isset($actions['cdata']) && ($count_actions = count($actions['cdata'])) )
		{
			for ( $j = 0; $j < $count_actions; $j++ )
			{
				$sqls = isset($actions['cdata'][$j]['actions']) ? $dbi->process($actions['cdata'][$j]['actions']) : false;
				unset($actions['cdata'][$j]);

				$count_sqls = $sqls ? count($sqls) : 0;
				for ( $k = 0; $k < $count_sqls; $k++ )
				{
					$result = $db->sql_query($sqls[$k], false, __LINE__, __FILE__, false);
					if ( $result === false )
					{
						$sql_error = $db->sql_error();
						$page->error(sprintf($page->lang('IN_sql_already_done'), ($sql_error['message'] ? $sql_error['message'] . ': ' : '') . $sqls[$k]));
					}
					else if ( $result !== true )
					{
						$db->sql_freeresult($result);
					}
					unset($result);
				}
				unset($sqls);
			}
		}
		unset($actions);
	}
	unset($dbi);
	unset($xml_parser);
	unset($schemas);

	// jump to end if not a migration from attachmod
	$parms['db'] = true;
	next_step(empty($parms['inpvreg']) ? 'IN_patch' : '');
	$page->loop();
}
if ( !empty($parms['db']) )
{
	$page->output(empty($parms['inpvch']) ? 'IN_db_done' : 'IN_db_upgraded');
}

// --------------------------
//
// finalize the installation
//
// --------------------------
if ( step() == 'IN_patch' )
{
	$config->set('mod_inline_banner_ad_version_CH', INLINE_BANNER_AD_CURRENT_VERSION, true);

	// instantiate the acting user
	$sav_lang = $lang;
	$user = new user();
	$user->read($session->user_id);

	// patch the panels
	$cp_panels = new cp_panels($requester);
	$cp_panels->read(true);
	$cp_panels->patch(true);

	// remove the acting user
	unset($user);
	$lang = $sav_lang;

	$parms['inp'] = true;
	next_step();
}
if ( !empty($parms['inp']) )
{
	$page->output('IN_panels_patched');
}

// all is done, recache
if ( step() == 'IN_end' )
{
	$sql = 'DELETE FROM ' . USERS_CACHE_TABLE;
	$db->sql_query($sql, false, __LINE__, __FILE__);

	$page->error(empty($parms['inpvch']) ? 'IN_install_done' : 'IN_install_upgraded');
	$page->critical_error('IN_return_to_board');
}

// send page
$page->header();
$page->footer();

?>